import { FernApiEditor } from "@fern-fern/api-editor-sdk";
import { Draft } from "immer";
import { ApiGraph } from "../api-graph/ApiGraph";
export declare namespace AbstractTransactionHandler {
    interface Init {
        definition: Draft<FernApiEditor.Api>;
        graph: ApiGraph;
    }
}
export declare abstract class AbstractTransactionHandler<T> {
    protected definition: Draft<FernApiEditor.Api>;
    protected graph: ApiGraph;
    constructor({ definition, graph }: AbstractTransactionHandler.Init);
    abstract applyTransaction(transaction: T): void;
    protected getPackageOrThrow(packageId: FernApiEditor.PackageId): Draft<FernApiEditor.Package>;
    protected getEndpointOrThrow(endpointId: FernApiEditor.EndpointId): Draft<FernApiEditor.Endpoint>;
    protected getErrorOrThrow(errorId: FernApiEditor.ErrorId): Draft<FernApiEditor.Error>;
    protected getTypeOrThrow(typeId: FernApiEditor.TypeId): Draft<FernApiEditor.Type>;
}
