export class AbstractTransactionHandler {
    definition;
    graph;
    constructor({ definition, graph }) {
        this.definition = definition;
        this.graph = graph;
    }
    getPackageOrThrow(packageId) {
        const package_ = this.definition.packages[packageId];
        if (package_ == null) {
            throw new Error(`Package ${packageId} does not exist`);
        }
        return package_;
    }
    getEndpointOrThrow(endpointId) {
        const endpoint = this.definition.endpoints[endpointId];
        if (endpoint == null) {
            throw new Error(`Endpoint ${endpointId} does not exist`);
        }
        return endpoint;
    }
    getErrorOrThrow(errorId) {
        const error = this.definition.errors[errorId];
        if (error == null) {
            throw new Error(`Error ${errorId} does not exist`);
        }
        return error;
    }
    getTypeOrThrow(typeId) {
        const type = this.definition.types[typeId];
        if (type == null) {
            throw new Error(`Type ${typeId} does not exist`);
        }
        return type;
    }
}
