import { AbstractDeleteTransactionHander } from "../AbstractDeleteTransactionHander";
export class DeletePackageTransactionHandler extends AbstractDeleteTransactionHander {
    removeDefinition(transaction) {
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this.definition.packages[transaction.packageId];
    }
    removeFromParent(transaction) {
        const parentId = this.graph.getPackageParent(transaction.packageId);
        if (parentId != null) {
            const parent = this.getPackageOrThrow(parentId);
            this.deletePackageFromList(transaction.packageId, parent.packages);
        }
        else {
            this.deletePackageFromList(transaction.packageId, this.definition.rootPackages);
        }
    }
    deletePackageFromList(packageToDelete, packages) {
        const indexOfPackage = packages.indexOf(packageToDelete);
        if (indexOfPackage === -1) {
            throw new Error(`Package ${packageToDelete} does not exist in parent`);
        }
        packages.splice(indexOfPackage, 1);
    }
    removeFromGraph(transaction) {
        this.graph.deletePackage(transaction.packageId);
    }
}
